/*
 * BeginInstruction.java
 *
 * Created on 16  2002 ., 10:02
 */

package com.fn.spcave.compiler;

/**
 *
 * @author  asso
 */
public class BeginInstruction extends Instruction implements Stackable {
    
    public static final int BEGIN_CODE = 1;
    private int endPosition;
    private boolean breaked;
    private int breakPosition;
    
    /** Creates a new instance of BeginInstruction */
    public BeginInstruction(Lexical lexical, String source, int line, int position) {
        super(lexical, source, line, position, BEGIN_CODE);
        endPosition = -1;
    }
    
    public void setEndPosition(int pos) {
        endPosition = pos;
    }
    
    public int getEndPosition() {
        return endPosition;
    }

    public void startExecution() {
        breaked = false;
    }
    
    public void exitTo(int pos) {
        breaked = true;
        breakPosition = pos;
    }
    
    public boolean isBreaked() {
        return breaked;
    }
    
    public int getBreakPos() {
        return breakPosition;
    }
}
