/*
 * ElseKeyword.java
 *
 * Created on 19  2002 ., 12:41
 */

package com.fn.spcave.compiler;


import java.util.List;


/**
 *
 * @author  asso
 */
public class ElseKeyword extends KeywordInstruction {
    
    /** Creates a new instance of ElseKeyword */
    public ElseKeyword(Lexical lexical, String source, int line, int position, 
            List arguments) throws ScException
    {
        super(lexical, source, line, position, arguments);
        if (position < 1)
            throw new ScException(getErrorPos() + "unexpected @else keyword");
        Instruction instr = getLexical().getInstruction(position - 1);
        if (instr.getCode() != EndInstruction.END_CODE)
            throw new ScException(getErrorPos() + "@else must be placed after @begin - @end block");
        int ifPos = ((EndInstruction)instr).getBeginPosition() - 1;
        if (ifPos < 1)
            throw new ScException(getErrorPos() + "@else without @if");
        instr = getLexical().getInstruction(ifPos);
        if (! (instr instanceof IfKeyword))
            throw new ScException(getErrorPos() + "@else found, but @if missing");
        ((IfKeyword)instr).setElsePosition(position);
    }
    
    public int processKeyword(Interpreter interp) throws ScException {
        throw new ScException(getErrorPos() + "invalid @else keyword");
  /*      int pos = getPosition();
        Instruction instr = getLexical().getInstruction(pos + 1);
        if (instr.getCode() != BeginInstruction.BEGIN_CODE)
            throw new ScException(getErrorPos() + "@else must followed by @begin - @end block");
        return ((BeginInstruction)instr).getEndPosition() + 1; */
    }
    
}
