/*
 * GetDateFunction.java
 *
 * Created on 19  2002 ., 17:01
 */

package com.fn.spcave.compiler;


import java.util.Calendar;
import java.util.Iterator;
import java.util.List;


/**
 *
 * @author  asso
 */
public class GetDateFunction implements FunctionHandler {
    
    /** Creates a new instance of GetDateFunction */
    public GetDateFunction() {
    }

    private String getMonthAsTwoDigits(Calendar cal) {
        String s = Integer.toString(cal.get(Calendar.MONTH));
        if (s.length() < 2)
            return "0" + s;
        else
            return s;
    }
    
    private String getYearAsTwoDigits(Calendar cal) {
        String s = Integer.toString(cal.get(Calendar.YEAR));
        if (s.length() > 2)
            return s.substring(s.length() - 2);
        else
            return s;
    }
    
    private String getDayAsTwoDigits(Calendar cal) {
        String s = Integer.toString(cal.get(Calendar.DAY_OF_MONTH));
        if (s.length() < 2)
            return "0" + s;
        else
            return s;
    }
    
    private String getYear(Calendar cal) {
        return Integer.toString(cal.get(Calendar.YEAR));
    }
    
    private String getMonth(Calendar cal) {
        return Integer.toString(cal.get(Calendar.MONTH));
    }
    
    private String getDay(Calendar cal) {
        return Integer.toString(cal.get(Calendar.DAY_OF_MONTH));
    }
    
    public Expression processFunction(Interpreter interp, List args) throws ScException {
        Calendar cal = Calendar.getInstance();
        StringBuffer sb = new StringBuffer();
        for (Iterator i = args.iterator(); i.hasNext(); ) {
            Expression expr = (Expression)i.next();
            String what = expr.asString(interp);
            if (what.equals("mm"))
                sb.append(getMonthAsTwoDigits(cal));
            else if (what.equals("m"))
                sb.append(getMonth(cal));
            else if (what.equals("yy"))
                sb.append(getYearAsTwoDigits(cal));
            else if (what.equals("yyyy"))
                sb.append(getYear(cal));
            else if (what.equals("dd"))
                sb.append(getDayAsTwoDigits(cal));
            else if (what.equals("d"))
                sb.append(getDay(cal));
            else sb.append(what);
        }
        return new Expression(sb.toString());
    }
    
}
