/*
 * GetPathFunction.java
 *
 * Created on 19  2002 ., 15:20
 */

package com.fn.spcave.compiler;


import java.util.List;


/**
 *
 * @author  asso
 */
public class GetPathFunction implements FunctionHandler {
    
    /** Creates a new instance of GetPathFunction */
    public GetPathFunction() {
    }
    
    public Expression processFunction(Interpreter interp, List args) throws ScException {
        if (args.size() > 1)
            throw new ScException("Too many arguments for getPath function");
        String localeName;
        if (args.size() > 0)
            localeName = ((Expression)args.get(0)).asString(interp);
        else
            localeName = interp.getVariable("locale").asString(interp);
        String path = interp.getVariable("path").asString(interp);
        String fileName = interp.getVariable("file").asString(interp);
        StringBuffer sb = new StringBuffer();
        sb.append("/").append(localeName);
        if (! path.startsWith("/"))
            sb.append('/');
        sb.append(path);
        if ((! path.endsWith("/")) && (! fileName.startsWith("/")) && (path.length() > 0))
            sb.append('/');
        sb.append(fileName);
        return new Expression(sb.toString());
    }
    
}
