/*
 * WhileKeyword.java
 *
 * Created on 16  2002 ., 14:41
 */

package com.fn.spcave.compiler;


import java.util.List;


/**
 *
 * @author  asso
 */
public class WhileKeyword extends KeywordInstruction implements Stackable {
    
    private int breakAddr = -1;
    
    /** Creates a new instance of WhileKeyword */
    public WhileKeyword(Lexical lexical, String source, int line, int position, 
            List arguments) throws ScException 
    {
        super(lexical, source, line, position, arguments);
        breakAddr = -1;
        if (arguments.size() != 1)
            throw new ScException(getErrorPos() + "while takes exacly one argument");
    }
    
    
    public int processKeyword(Interpreter interp) throws ScException {
        Instruction instr = getLexical().getInstruction(getPosition() + 1);
        if (instr.getCode() != BeginInstruction.BEGIN_CODE)
            throw new ScException(getErrorPos() + "while must be followed by @begin statement");
        BeginInstruction begin = (BeginInstruction)instr;
        while ((breakAddr == -1) && (((Expression)getArguments().get(0)).asBoolean(interp))) {
            interp.processBlock(getLexical(), getPosition() + 1);
        }
        if (breakAddr != -1)
            return breakAddr;
        return begin.getEndPosition() + 1;
    }

    
    public void exitTo(int pos) {
        breakAddr = pos;
    }
    
}
