/*
 * GetNewsMinYearFunction.java
 *
 * Created on 22  2002 ., 15:48
 */

package com.fn.station;


import java.util.Iterator;
import java.util.List;
import com.fn.spcave.compiler.*;


/**
 *
 * @author  asso
 */
public class GetNewsMinYearFunction implements FunctionHandler {
    
    /** Creates a new instance of GetNewsMinYearFunction */
    public GetNewsMinYearFunction() {
    }
    
    public Expression processFunction(Interpreter interp, List args) throws ScException {
        if (args.size() != 1)
            throw new ScException("@getNewsMinYear function takes exacly one argument");
        Expression expr = (Expression)args.get(0);
      /*  if ((! expr.isCustomType(interp)) || (! (expr.getCustomData(interp) instanceof NewsFile)))
            throw new ScException("Invalid argument of @getNewsMinYear function");*/
        NewsFile nf = (NewsFile)expr.getCustomData(interp);
        int minYear = -1;
        for (Iterator i = nf.getIterator(); i.hasNext(); ) {
            NewsFile.NewsEntry ne = (NewsFile.NewsEntry)i.next();
            if (minYear == -1)
                minYear = ne.year;
            else
                if (ne.year < minYear)
                    minYear = ne.year;
        }
        return new Expression(minYear);
    }
    
}
